import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;
import javax.microedition.io.StreamConnection;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.String;

class Lib_ftp {
    
  private static SocketConnection c;
  private static InputStream i;
  private static OutputStream o;
  
  private static int     OpenState = 0;
  private static String  ServerResponse = "";
  private static String  SrvAddress = "";


  
  
  public static String ftpsendstr(String FileName, String Data) {

    String[] ParseParam = {"","","","","","",""};
    int TempPort = 0; 
    String TempPortStr   = ""; 
    String TempIPStr     = ""; 
        
    String TempString = "";
    SocketConnection TempSocket = null;
    OutputStream TempStream = null;
    
    
    socketwritestr("REST" + (char)13 + (char)10);
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 350) {
        return ServerResponse;
        }

    
    socketwritestr("TYPE I" + (char)13 + (char)10);
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 200) {
        return ServerResponse;
        }
    
    socketwritestr("PASV" + (char)13 + (char)10);
    ServerResponse = ResponseStringRead();
    if (Integer.parseInt(ServerResponse.substring(0, 3)) != 227) {
        return ServerResponse;
        }

   TempString =  ServerResponse.substring(ServerResponse.indexOf("(")+1, ServerResponse.length()-3);

   int CountParam = 1;

   for (int i = 0; i < TempString.length(); i++) {
       if (TempString.charAt(i) == (char)44) {
           CountParam++;
           }
       else {
       ParseParam[CountParam] = ParseParam[CountParam] + TempString.charAt(i);
           }
       }
   
  TempIPStr = ParseParam[1] + "." + ParseParam[2] + "." +  ParseParam[3] + "." + ParseParam[4];
  TempPortStr = ParseParam[5] + ":" + ParseParam[6];
  TempPort = 256*Integer.parseInt(ParseParam[5]) + Integer.parseInt(ParseParam[6]);
  

  socketwritestr("STOR " + FileName + (char)13 + (char)10);
    
    try{
      TempSocket = (SocketConnection) Connector.open("socket://" + TempIPStr + ":" + Integer.toString(TempPort));
      TempStream = TempSocket.openOutputStream();
    }catch(Exception ex) {}

    
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 150) {
        return ServerResponse;
        }
    
    
    byte[] TempChar;
    TempChar = Data.getBytes();
    
    try{
      TempStream.write(TempChar);
      TempStream.flush();
    }catch(Exception ex) {}
    
    try{
      TempSocket.close();
      TempSocket = null;
      TempStream.close();
      TempStream = null;
    }catch(Exception ex) {}

    
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 226) {
        return ServerResponse;
        }
    return ServerResponse;
  }
 
  
  public static String ftpopen(String ServerAddress, String UserName, String UserPassword) {
  
    OpenState = socketopen ("socket://" + ServerAddress + ":21");
    
    if (OpenState != 0) {
        return "Connection Error";
    }
            
    SrvAddress = ServerAddress;
    
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 220) {
        return ServerResponse;
        }

    socketwritestr("USER " + UserName + (char)13 + (char)10);
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 331) {
        return ServerResponse;
        }

    socketwritestr("PASS " + UserPassword + (char)13 + (char)10);
    ServerResponse = ResponseStringRead().substring(0, 3);
    if (Integer.parseInt(ServerResponse) != 230) {
        return ServerResponse;
        }
    
   
    return "OK";
  }
  
  
  public static void ftpclose() {
      socketwritestr("QUIT" + (char)13 + (char)10);
      socketclose();  
  }

  
  
  
  
  
  
  

  public static int socketopen(String url) {
    try{
      c = (SocketConnection) Connector.open(url);
      i = c.openInputStream();
      o = c.openOutputStream();
    }catch(Exception ex) {return -1;}
    return 0;
  }

  
  public static void socketclose() {
    try{
      if(i != null) {
        i.close();
        i = null;
      }
      if(o != null) {
        o.flush();
        o.close();
        o = null;
      }
      c.close();
      c = null;
    }catch(Exception ex) {c = null;}
  }

//      
// @return int
  public static int socketavailable() {
    if(i != null)
      try{
        return i.available();
      }catch(Exception ex) {}
    return 0;
  }

//     
// @return int
  public static String ResponseStringRead() {
    String TempString = "";  

    
    if(i != null) 
    try{ while (i.available() == 0) {} } 
    catch(Exception ex) {}
    

    if(i != null) 
      try{
          while (i.available() != 0) {
            TempString = TempString + (char)i.read();
              }
          } 
      catch(Exception ex) {return "";}

    return TempString;
  }
  
  
//     
// @return int
  public static int socketread() {
    try{
      return i.read();
    }catch(Exception ex) {}
    return -1;
  }


//     
// @return int
  public static int socketwritestr(String sendstr) {
    byte[] sendchar;
    sendchar = sendstr.getBytes();
    try{
      o.write(sendchar);
      o.flush();
      return 0;
    }catch(Exception ex) {return -1;}
  }
  
 }
